import * as _rhjs_rh from '@rhjs/rh';
import { reactivity } from '@rhjs/rh';

type AccordionExpandMode = 'single' | 'multi';
type AccordionProps = {
    expandMode?: AccordionExpandMode;
};
declare const Accordion: ({ expandMode, ...props }: AccordionProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type RefOrValue<T> = T extends reactivity.Ref<any> ? T : reactivity.Ref<T> | T;

type AccordionItemExpandMode = 'single' | 'multi';
type AccordionItemProps = {
    headingLevel?: RefOrValue<1 | 2 | 3 | 4 | 5>;
    expanded?: RefOrValue<boolean>;
    disabled?: RefOrValue<boolean>;
    slotHeading?: any;
};
declare const AccordionItem: ({ headingLevel, slotHeading, ...props }: AccordionItemProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type AnchorProps = {
    slotStart?: any;
    slotEnd?: any;
};
declare const Anchor: ({ slotStart, slotEnd, ...props }: AnchorProps & JSX.HTMLAttributes<HTMLAnchorElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

declare enum AxisPositioningMode {
    uncontrolled = "uncontrolled",
    locktodefault = "locktodefault",
    dynamic = "dynamic"
}
declare enum AxisScalingMode {
    anchor = "anchor",
    content = "content",
    fill = "fill"
}
declare enum HorizontalPosition {
    start = "start",
    end = "end",
    left = "left",
    right = "right",
    center = "center",
    unset = "unset"
}
declare enum VerticalPosition {
    top = "top",
    bottom = "bottom",
    center = "center",
    unset = "unset"
}
type AnchoredRegionProps = {
    regionView?: any;
    verticalPositioningMode?: RefOrValue<AxisPositioningMode>;
    verticalDefaultPosition?: RefOrValue<VerticalPosition>;
    verticalViewportLock?: RefOrValue<boolean>;
    verticalInset?: RefOrValue<boolean>;
    verticalThreshold?: RefOrValue<number>;
    verticalScaling?: RefOrValue<AxisScalingMode>;
    horizontalPositioningMode?: RefOrValue<AxisPositioningMode>;
    horizontalDefaultPosition?: RefOrValue<HorizontalPosition>;
    horizontalViewportLock?: RefOrValue<boolean>;
    horizontalInset?: RefOrValue<boolean>;
    horizontalThreshold?: RefOrValue<number>;
    horizontalScaling?: RefOrValue<AxisScalingMode>;
    fixedPlacement?: RefOrValue<boolean>;
    autoUpdateMode?: RefOrValue<boolean>;
};
declare const AnchoredRegion: ({ regionView, ...props }: AnchoredRegionProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type BadgeAppearance = 'accent' | 'lightweight' | 'neutral' | string;
type BadgeProps = {
    appearance?: BadgeAppearance;
};
declare const Badge: ({ ...props }: BadgeProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type BreadcrumbProps = {};
declare const Breadcrumb: ({ ...props }: BreadcrumbProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type BreadcrumbItemExpandMode = 'single' | 'multi';
type BreadcrumbItemProps = {
    slotStart?: any;
    slotEnd?: any;
    slotSeparator?: any;
};
declare const BreadcrumbItem: ({ slotEnd, slotStart, slotSeparator, ...props }: BreadcrumbItemProps & JSX.HTMLAttributes<HTMLAnchorElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type ButtonAppearance = 'accent' | 'lightweight' | 'neutral' | 'outline' | 'stealth';
type ButtonProps = {
    appearance?: ButtonAppearance;
    autofocus?: boolean;
    slotStart?: any;
    slotEnd?: any;
};
declare const Button: ({ slotStart, slotEnd, ...props }: ButtonProps & JSX.HTMLAttributes<HTMLButtonElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type CardProps = {
    width?: number | string;
    height?: number | string;
};
declare const Card: ({ width, height, ...props }: CardProps & Omit<JSX.HTMLAttributes<HTMLDivElement>, 'width' | 'height'>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type CheckboxProps = {
    checked?: RefOrValue<boolean>;
    disabled?: RefOrValue<boolean>;
};
declare const Checkbox: ({ ...props }: CheckboxProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type ComboboxAutocomplete = 'inline' | 'list' | 'both' | 'none';
type ComboboxProps = {
    placeholder?: RefOrValue<string>;
    disabled?: RefOrValue<string>;
    autocomplete?: RefOrValue<ComboboxAutocomplete>;
    open?: RefOrValue<boolean>;
};
declare const Combobox: ({ ...props }: ComboboxProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type DividerProps = {};
declare const Divider: ({ ...props }: DividerProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type GenerateHeaderOptions = 'default' | 'none' | 'sticky';
type DataGridProps = {
    rowsData?: Record<keyof any, any>[];
    noTabbing?: RefOrValue<boolean>;
    generateHeader?: GenerateHeaderOptions;
    gridTemplateColumns?: RefOrValue<string>;
};
declare const DataGrid: ({ rowsData, ...props }: DataGridProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type FlipperProps = {};
declare const Flipper: ({ ...props }: FlipperProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type HorizontalScrollProps = {
    view?: RefOrValue<'default' | 'mobile'>;
    duration?: RefOrValue<string>;
    speed?: RefOrValue<number>;
    easing?: RefOrValue<string>;
};
declare const HorizontalScroll: ({ ...props }: HorizontalScrollProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type MenuProps = {};
declare const Menu: ({ ...props }: MenuProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type MenuItemRole = 'menuitem' | 'menuitemcheckbox' | 'menuitemradio';
type MenuItemProps = {
    role?: MenuItemRole;
};
declare const MenuItem: ({ ...props }: MenuItemProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type NumberFieldProps = {
    value?: RefOrValue<number>;
    bindValue?: boolean;
};
declare const NumberField: ({ bindValue, ...props }: NumberFieldProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type ProgressProps = {
    value?: RefOrValue<number | null>;
    max?: RefOrValue<number>;
    min?: RefOrValue<number>;
};
declare const Progress: ({ ...props }: ProgressProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type ProgressRingProps = {};
declare const ProgressRing: ({ ...props }: ProgressRingProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type RadioExpandMode = 'single' | 'multi';
type RadioProps = {
    checked?: RefOrValue<boolean>;
    disabled?: RefOrValue<boolean>;
};
declare const Radio: ({ ...props }: RadioProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type RadioGroupProps = {
    orientation?: RefOrValue<'vertical' | 'horizontal'>;
};
declare const RadioGroup: ({ ...props }: RadioGroupProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type SelectProps = {
    open?: RefOrValue<boolean>;
};
declare const Select: ({ ...props }: SelectProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type ListBoxProps = {};
declare const ListBox: ({ ...props }: ListBoxProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type ListOptionExpandMode = 'single' | 'multi';
type ListOptionProps = {
    value?: string;
    selected?: RefOrValue<boolean>;
    disabled?: RefOrValue<boolean>;
    slotStart?: any;
    slotEnd?: any;
};
declare const ListOption: ({ slotEnd, slotStart, ...props }: ListOptionProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type SkeletonProps = {
    fill?: RefOrValue<string>;
    shape?: RefOrValue<'rect' | 'circle'>;
    pattern?: RefOrValue<string>;
    shimmer?: RefOrValue<boolean>;
};
declare const Skeleton: ({ ...props }: SkeletonProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type SliderExpandMode = 'single' | 'multi';
type SliderProps = {
    readonly?: RefOrValue<boolean>;
    min?: RefOrValue<number>;
    max?: RefOrValue<number>;
    step?: RefOrValue<number>;
    orientation?: RefOrValue<'vertical' | 'horizontal'>;
    mode?: 'single-value';
    slotTrack?: any;
    slotTrackStart?: any;
    slotThumb?: any;
};
declare const Slider: ({ slotThumb, slotTrack, slotTrackStart, ...props }: SliderProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type SliderLabelExpandMode = 'single' | 'multi';
type SliderLabelProps = {
    position?: RefOrValue<string>;
    hideMark?: RefOrValue<boolean>;
    disabled?: RefOrValue<boolean>;
    orientation?: RefOrValue<'vertical' | 'horizontal'>;
};
declare const SliderLabel: ({ ...props }: SliderLabelProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type SwitchProps = {
    slotCheckedMessage?: any;
    slotUnCheckedMessage?: any;
    readonly?: RefOrValue<boolean>;
};
declare const Switch: ({ slotCheckedMessage, slotUnCheckedMessage, ...props }: SwitchProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type TabsOrientation = 'vertical' | 'horizontal';
type TabsProps = {
    orientation?: TabsOrientation;
    tabs?: {
        title: string;
        view?: any;
        defaultActivated?: boolean;
    }[];
};
declare const Tabs: ({ tabs, ...props }: TabsProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type TextAreaProps = {
    placeholder?: RefOrValue<string>;
    readonly?: RefOrValue<boolean>;
    resize?: RefOrValue<boolean>;
    autofocus?: RefOrValue<boolean>;
    maxlength?: RefOrValue<number>;
    minlength?: RefOrValue<number>;
    name?: RefOrValue<string>;
    cols?: RefOrValue<number>;
    rows?: RefOrValue<number>;
    spellcheck?: RefOrValue<boolean>;
};
declare const TextArea: ({ ...props }: TextAreaProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type TextFieldType = 'email' | 'password' | 'tel' | 'text' | 'url';
type TextFieldProps = {
    type?: RefOrValue<TextFieldType>;
    placeholder?: RefOrValue<string>;
    readonly?: RefOrValue<boolean>;
    resize?: RefOrValue<boolean>;
    autofocus?: RefOrValue<boolean>;
    maxlength?: RefOrValue<number>;
    minlength?: RefOrValue<number>;
    pattern?: RefOrValue<string>;
    size?: RefOrValue<number>;
    spellcheck?: RefOrValue<boolean>;
};
declare const TextField: ({ ...props }: TextFieldProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type TooltipPosition = 'top' | 'right' | 'bottom' | 'left' | 'start' | 'end' | 'top-left' | 'top-right' | 'bottom-left' | 'bottom-right' | 'top-start' | 'top-end' | 'bottom-start' | 'bottom-end';
type TooltipProps = {
    position?: RefOrValue<TooltipPosition>;
    delay?: RefOrValue<number>;
    autoUpdateMode?: RefOrValue<'auto' | 'anchor'>;
    horizontalViewportLock?: RefOrValue<boolean>;
    verticalViewportLock?: RefOrValue<boolean>;
    visible?: RefOrValue<boolean>;
    tooltipView?: any;
};
declare const Tooltip: ({ tooltipView, ...props }: TooltipProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type TreeViewProps = {};
declare const TreeView: ({ ...props }: TreeViewProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type TreeItemProps = {
    expanded?: RefOrValue<boolean>;
    selected?: RefOrValue<boolean>;
    disabled?: RefOrValue<boolean>;
    nested?: RefOrValue<boolean>;
    onExpandedChange?: (event: CustomEvent) => any;
    onSelectedChange?: (event: CustomEvent) => any;
};
declare const TreeItem: ({ onExpandedChange, onSelectedChange, ...props }: TreeItemProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

type DesignSystemProviderKeys = 'no-paint' | 'fill-color' | 'accent-base-color' | 'neutral-base-color' | 'design-unit' | 'direction' | 'base-height-multiplier' | 'base-horizontal-spacing-multiplier' | 'control-corner-radius' | 'layer-corner-radius' | 'stroke-width' | 'focus-stroke-width' | 'disabled-opacity' | 'type-ramp-minus-2-font-size' | 'type-ramp-minus-2-line-height' | 'type-ramp-minus-1-font-size' | 'type-ramp-minus-1-line-height' | 'type-ramp-base-font-size' | 'type-ramp-base-line-height' | 'type-ramp-plus-1-font-size' | 'type-ramp-plus-1-line-height' | 'type-ramp-plus-2-font-size' | 'type-ramp-plus-2-line-height' | 'type-ramp-plus-3-font-size' | 'type-ramp-plus-3-line-height' | 'type-ramp-plus-4-font-size' | 'type-ramp-plus-4-line-height' | 'type-ramp-plus-5-font-size' | 'type-ramp-plus-5-line-height' | 'type-ramp-plus-6-font-size' | 'type-ramp-plus-6-line-height' | 'accent-fill-rest-delta' | 'accent-fill-hover-delta' | 'accent-fill-active-delta' | 'accent-fill-focus-delta' | 'accent-foreground-rest-delta' | 'accent-foreground-hover-delta' | 'accent-foreground-active-delta' | 'accent-foreground-focus-delta' | 'neutral-fill-rest-delta' | 'neutral-fill-hover-delta' | 'neutral-fill-active-delta' | 'neutral-fill-focus-delta' | 'neutral-fill-input-rest-delta' | 'neutral-fill-input-hover-delta' | 'neutral-fill-input-active-delta' | 'neutral-fill-input-focus-delta' | 'neutral-fill-layer-rest-delta' | 'neutral-fill-stealth-rest-delta' | 'neutral-fill-stealth-hover-delta' | 'neutral-fill-stealth-active-delta' | 'neutral-fill-stealth-focus-delta' | 'neutral-fill-strong-hover-delta' | 'neutral-fill-strong-active-delta' | 'neutral-fill-strong-focus-delta' | 'base-layer-luminance' | 'neutral-stroke-divider-rest-delta' | 'neutral-stroke-rest-delta' | 'neutral-stroke-hover-delta' | 'neutral-stroke-active-delta' | 'neutral-stroke-focus-delta';
type DesignSystemProviderProps = {
    [K in DesignSystemProviderKeys]?: RefOrValue<string | number>;
};
declare const DesignSystemProvider: ({ ...props }: DesignSystemProviderProps & JSX.HTMLAttributes<HTMLDivElement>, ...children: any[]) => () => NonNullable<_rhjs_rh.rhView>;

declare const fluentUIWebComponentsLoaded: reactivity.Ref<boolean>;
/**
 * load fluent ui
 *
 * @param src import fluent ui web components from url. Default import from `https://unpkg.com/@fluentui/web-components`
 * @returns
 */
declare const ensureFluentUILoaded: (src?: string) => Promise<boolean>;

export { Accordion, AccordionExpandMode, AccordionItem, AccordionItemExpandMode, AccordionItemProps, AccordionProps, Anchor, AnchorProps, AnchoredRegion, AnchoredRegionProps, Badge, BadgeAppearance, BadgeProps, Breadcrumb, BreadcrumbItem, BreadcrumbItemExpandMode, BreadcrumbItemProps, BreadcrumbProps, Button, ButtonAppearance, ButtonProps, Card, CardProps, Checkbox, CheckboxProps, Combobox, ComboboxAutocomplete, ComboboxProps, DataGrid, DataGridProps, DesignSystemProvider, DesignSystemProviderKeys, DesignSystemProviderProps, Divider, DividerProps, Flipper, FlipperProps, GenerateHeaderOptions, HorizontalScroll, HorizontalScrollProps, ListBox, ListBoxProps, ListOption, ListOptionExpandMode, ListOptionProps, Menu, MenuItem, MenuItemProps, MenuItemRole, MenuProps, NumberField, NumberFieldProps, Progress, ProgressProps, ProgressRing, ProgressRingProps, Radio, RadioExpandMode, RadioGroup, RadioGroupProps, RadioProps, Select, SelectProps, Skeleton, SkeletonProps, Slider, SliderExpandMode, SliderLabel, SliderLabelExpandMode, SliderLabelProps, SliderProps, Switch, SwitchProps, Tabs, TabsOrientation, TabsProps, TextArea, TextAreaProps, TextField, TextFieldProps, TextFieldType, Tooltip, TooltipPosition, TooltipProps, TreeItem, TreeItemProps, TreeView, TreeViewProps, ensureFluentUILoaded, fluentUIWebComponentsLoaded };
